<?php
// +----------------------------------------------------------------------
// | CRMEB [ CRMEB赋能开发者，助力企业发展 ]
// +----------------------------------------------------------------------
// | Copyright (c) 2016~2020 https://www.crmeb.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed CRMEB并不是自由软件，未经许可不能去掉CRMEB相关版权
// +----------------------------------------------------------------------
// | Author: CRMEB Team <admin@crmeb.com>
// +----------------------------------------------------------------------

namespace crmeb\services\easywechat;


use crmeb\services\easywechat\oauth2\wechat\WechatOauth2Provider;
use crmeb\services\easywechat\subscribe\roution\ProgramProvider;
use crmeb\services\easywechat\subscribe\wechat\WechatSubscribe;
use crmeb\services\easywechat\subscribe\wechat\WechatSubsribeProvider;
use crmeb\services\easywechat\wechatlive\ProgramProvider as LiveProgramProvider;
use crmeb\services\easywechat\work\ProgramProvider as WorkProgramProvider;
use crmeb\services\easywechat\work\ProgramWork;

/**
 * Class Application
 * @package crmeb\services\easywechat
 * @property ProgramProvider $now_notice
 * @property LiveProgramProvider $wechat_live
 * @property ProgramWork $program_work
 * @property WechatSubscribe $newtmpl
 * @property WechatOauth2Provider $oauth2
 */
class Application extends \EasyWeChat\Foundation\Application
{

    /**
     * @var string[]
     */
    protected $providersNew = [
        ProgramProvider::class,
        LiveProgramProvider::class,
        WorkProgramProvider::class,
        WechatSubsribeProvider::class,
        WechatOauth2Provider::class
    ];

    /**
     * Application constructor.
     * @param $config
     */
    public function __construct($config)
    {
        $this->providers = array_merge($this->providers, $this->providersNew);
        parent::__construct($config);
    }

}
